/********************************************************************
	Rhapsody	: 6.1 
	Login		: Masood Khosroshahy
	Component	: mainComponent 
	Configuration 	: DefaultConfig
	Model Element	: Router
//!	Generated Date	: Tue, 28, Mar 2006  
	File Path	: mainComponent/DefaultConfig/Router.cpp
*********************************************************************/


//#[ ignore 
#define NAMESPACE_PREFIX 


#define _OMSTATECHART_ANIMATED 
//#]

#include "Router.h"

//## package Rip 


//#[ ignore 
#define Rip_Router_Router_SERIALIZE OM_NO_OP


#define Rip_Router_countingNumberOfNeighbours_SERIALIZE OM_NO_OP


#define Rip_Router_send_RIPtable_SERIALIZE OM_NO_OP
//#]

//----------------------------------------------------------------------------
// Router.cpp                                                                  
//----------------------------------------------------------------------------
DECLARE_META_PACKAGE(Rip)
//## class Router 



Router::Router(IOxfActive* theActiveContext) : NbNodes(4) ,i(0) ,j(0) ,k(0) ,m(0) ,n(0) ,numberOfInitializationMessagesReceived(0) ,numberOfReceivedRIPMessages(0) {
    NOTIFY_REACTIVE_CONSTRUCTOR(Router, Router(), 0, Rip_Router_Router_SERIALIZE);
    setActiveContext(theActiveContext, false);
    initRelations();
    initStatechart();
}

Router::~Router() {
    NOTIFY_DESTRUCTOR(~Router, false);
    cleanUpRelations();
}

Router::pScheduler_C* Router::getPScheduler() const {
    return pScheduler;
}

Router::pScheduler_C* Router::get_pScheduler() const {
    return pScheduler;
}

Router::pScheduler_C* Router::newPScheduler() {
    pScheduler = new Router::pScheduler_C;
    return pScheduler;
}

void Router::deletePScheduler() {
    delete pScheduler;
    pScheduler = NULL;
}

Router::pRIP2_C* Router::getPRIP2() const {
    return pRIP2;
}

Router::pRIP2_C* Router::get_pRIP2() const {
    return pRIP2;
}

Router::pRIP2_C* Router::newPRIP2() {
    pRIP2 = new Router::pRIP2_C;
    return pRIP2;
}

void Router::deletePRIP2() {
    delete pRIP2;
    pRIP2 = NULL;
}

Router::pRIP1_C* Router::getPRIP1() const {
    return pRIP1;
}

Router::pRIP1_C* Router::get_pRIP1() const {
    return pRIP1;
}

Router::pRIP1_C* Router::newPRIP1() {
    pRIP1 = new Router::pRIP1_C;
    return pRIP1;
}

void Router::deletePRIP1() {
    delete pRIP1;
    pRIP1 = NULL;
}

Router::pRIP3_C* Router::getPRIP3() const {
    return pRIP3;
}

Router::pRIP3_C* Router::get_pRIP3() const {
    return pRIP3;
}

Router::pRIP3_C* Router::newPRIP3() {
    pRIP3 = new Router::pRIP3_C;
    return pRIP3;
}

void Router::deletePRIP3() {
    delete pRIP3;
    pRIP3 = NULL;
}

Router::pRIP4_C* Router::getPRIP4() const {
    return pRIP4;
}

Router::pRIP4_C* Router::get_pRIP4() const {
    return pRIP4;
}

Router::pRIP4_C* Router::newPRIP4() {
    pRIP4 = new Router::pRIP4_C;
    return pRIP4;
}

void Router::deletePRIP4() {
    delete pRIP4;
    pRIP4 = NULL;
}

void Router::countingNumberOfNeighbours() {
    NOTIFY_OPERATION(countingNumberOfNeighbours, countingNumberOfNeighbours(), 0, Rip_Router_countingNumberOfNeighbours_SERIALIZE);
    //#[ operation countingNumberOfNeighbours() 
    numberOfNeighbours = 0;
    for (int i=0 ; i<3 ; i++)
    	if (neighbours.Array[i] > 0)
    		numberOfNeighbours++;
    
    //#]
}

void Router::send_RIPtable() {
    NOTIFY_OPERATION(send_RIPtable, send_RIPtable(), 0, Rip_Router_send_RIPtable_SERIALIZE);
    //#[ operation send_RIPtable() 
    
    for (int i=0 ; i<3 ; i++)
    {
    	switch (neighbours.Array[i])
    	//Sending RIP messages through the respective ports
    	{
    	case 1:  
    			for (int x =4 ; x > toSendRIPMessages.ArrayNbLine[0] ; x--)
    			{
    				toSendRIPMessages.Array[0].ArrayRIPLine[x-1].Destination = 88;
    				toSendRIPMessages.Array[0].ArrayRIPLine[x-1].Cost = 88 ; 
    			}
    			
    			OUT_PORT(pRIP1)->GEN(evRIP(
    			toSendRIPMessages.ArrayNbLine[0] , toSendRIPMessages.Array[0], 
    			toSendRIPMessages.Array[0].ArrayRIPLine[0].Destination ,
    			toSendRIPMessages.Array[0].ArrayRIPLine[0].Cost , 
    			toSendRIPMessages.Array[0].ArrayRIPLine[1].Destination ,
    			toSendRIPMessages.Array[0].ArrayRIPLine[1].Cost  ,
    			toSendRIPMessages.Array[0].ArrayRIPLine[2].Destination ,
    			toSendRIPMessages.Array[0].ArrayRIPLine[2].Cost   ,
    			toSendRIPMessages.Array[0].ArrayRIPLine[3].Destination ,
    			toSendRIPMessages.Array[0].ArrayRIPLine[3].Cost   
    			));
    			break;
    	case 2: 			
    			for (int x =4 ; x > toSendRIPMessages.ArrayNbLine[1] ; x--)
    			{
    				toSendRIPMessages.Array[1].ArrayRIPLine[x-1].Destination = 88;
    				toSendRIPMessages.Array[1].ArrayRIPLine[x-1].Cost = 88 ; 
    			}
    
    			OUT_PORT(pRIP2)->GEN(evRIP(
    			toSendRIPMessages.ArrayNbLine[1] , toSendRIPMessages.Array[1], 
    			toSendRIPMessages.Array[1].ArrayRIPLine[0].Destination ,
    			toSendRIPMessages.Array[1].ArrayRIPLine[0].Cost , 
    			toSendRIPMessages.Array[1].ArrayRIPLine[1].Destination ,
    			toSendRIPMessages.Array[1].ArrayRIPLine[1].Cost  ,
    			toSendRIPMessages.Array[1].ArrayRIPLine[2].Destination ,
    			toSendRIPMessages.Array[1].ArrayRIPLine[2].Cost   ,
    			toSendRIPMessages.Array[1].ArrayRIPLine[3].Destination ,
    			toSendRIPMessages.Array[1].ArrayRIPLine[3].Cost   
    			));
    			break;
    	case 3: 			
    			for (int x =4 ; x > toSendRIPMessages.ArrayNbLine[2] ; x--)
    			{
    				toSendRIPMessages.Array[2].ArrayRIPLine[x-1].Destination = 88;
    				toSendRIPMessages.Array[2].ArrayRIPLine[x-1].Cost = 88 ; 
    			}
    
    			OUT_PORT(pRIP3)->GEN(evRIP(
    			toSendRIPMessages.ArrayNbLine[2] , toSendRIPMessages.Array[2], 
    			toSendRIPMessages.Array[2].ArrayRIPLine[0].Destination ,
    			toSendRIPMessages.Array[2].ArrayRIPLine[0].Cost , 
    			toSendRIPMessages.Array[2].ArrayRIPLine[1].Destination ,
    			toSendRIPMessages.Array[2].ArrayRIPLine[1].Cost  ,
    			toSendRIPMessages.Array[2].ArrayRIPLine[2].Destination ,
    			toSendRIPMessages.Array[2].ArrayRIPLine[2].Cost   ,
    			toSendRIPMessages.Array[2].ArrayRIPLine[3].Destination ,
    			toSendRIPMessages.Array[2].ArrayRIPLine[3].Cost   
    			));
    			break;
    	case 4: 			
    			for (int x =4 ; x > toSendRIPMessages.ArrayNbLine[3] ; x--)
    			{
    				toSendRIPMessages.Array[3].ArrayRIPLine[x-1].Destination = 88;
    				toSendRIPMessages.Array[3].ArrayRIPLine[x-1].Cost = 88 ; 
    			}
    
    			OUT_PORT(pRIP4)->GEN(evRIP(
    			toSendRIPMessages.ArrayNbLine[3] , toSendRIPMessages.Array[3], 
    			toSendRIPMessages.Array[3].ArrayRIPLine[0].Destination ,
    			toSendRIPMessages.Array[3].ArrayRIPLine[0].Cost , 
    			toSendRIPMessages.Array[3].ArrayRIPLine[1].Destination ,
    			toSendRIPMessages.Array[3].ArrayRIPLine[1].Cost  ,
    			toSendRIPMessages.Array[3].ArrayRIPLine[2].Destination ,
    			toSendRIPMessages.Array[3].ArrayRIPLine[2].Cost   ,
    			toSendRIPMessages.Array[3].ArrayRIPLine[3].Destination ,
    			toSendRIPMessages.Array[3].ArrayRIPLine[3].Cost   
    			));
    			break;
    	}
    }         
    
    numberOfNeighbours = 0;
    for (int i=0 ; i<3 ; i++)
    	if (neighbours.Array[i] > 0)
    		numberOfNeighbours++;
    
    //#]
}

int Router::getNbNodes() const {
    return NbNodes;
}

void Router::setNbNodes(int p_NbNodes) {
    NbNodes = p_NbNodes;
}

int Router::getCost() const {
    return cost;
}

void Router::setCost(int p_cost) {
    cost = p_cost;
}

int Router::getDest() const {
    return dest;
}

void Router::setDest(int p_dest) {
    dest = p_dest;
}

int Router::getI() const {
    return i;
}

void Router::setI(int p_i) {
    i = p_i;
}

int Router::getJ() const {
    return j;
}

void Router::setJ(int p_j) {
    j = p_j;
}

int Router::getK() const {
    return k;
}

void Router::setK(int p_k) {
    k = p_k;
}

int Router::getL() const {
    return l;
}

void Router::setL(int p_l) {
    l = p_l;
}

int Router::getM() const {
    return m;
}

void Router::setM(int p_m) {
    m = p_m;
}

int Router::getN() const {
    return n;
}

void Router::setN(int p_n) {
    n = p_n;
}

int Router::getN_line() const {
    return n_line;
}

void Router::setN_line(int p_n_line) {
    n_line = p_n_line;
}

int Router::getNb_line() const {
    return nb_line;
}

void Router::setNb_line(int p_nb_line) {
    nb_line = p_nb_line;
}

NeighboursTable Router::getNeighbours() const {
    return neighbours;
}

void Router::setNeighbours(NeighboursTable p_neighbours) {
    neighbours = p_neighbours;
}

int Router::getNext() const {
    return next;
}

void Router::setNext(int p_next) {
    next = p_next;
}

int Router::getNumberOfInitializationMessagesReceived() const {
    return numberOfInitializationMessagesReceived;
}

void Router::setNumberOfInitializationMessagesReceived(int p_numberOfInitializationMessagesReceived) {
    numberOfInitializationMessagesReceived = p_numberOfInitializationMessagesReceived;
}

int Router::getNumberOfNeighbours() const {
    return numberOfNeighbours;
}

void Router::setNumberOfNeighbours(int p_numberOfNeighbours) {
    numberOfNeighbours = p_numberOfNeighbours;
}

int Router::getNumberOfReceivedRIPMessages() const {
    return numberOfReceivedRIPMessages;
}

void Router::setNumberOfReceivedRIPMessages(int p_numberOfReceivedRIPMessages) {
    numberOfReceivedRIPMessages = p_numberOfReceivedRIPMessages;
}

RIPTable Router::getReceived_rip() const {
    return received_rip;
}

void Router::setReceived_rip(RIPTable p_received_rip) {
    received_rip = p_received_rip;
}

int Router::getReceiverRouterID() const {
    return receiverRouterID;
}

void Router::setReceiverRouterID(int p_receiverRouterID) {
    receiverRouterID = p_receiverRouterID;
}

RIPMessages Router::getRipMessagesReceived() const {
    return ripMessagesReceived;
}

void Router::setRipMessagesReceived(RIPMessages p_ripMessagesReceived) {
    ripMessagesReceived = p_ripMessagesReceived;
}

RIPTable Router::getRip_msg() const {
    return rip_msg;
}

void Router::setRip_msg(RIPTable p_rip_msg) {
    rip_msg = p_rip_msg;
}

RoutingTable Router::getRouteT() const {
    return routeT;
}

void Router::setRouteT(RoutingTable p_routeT) {
    routeT = p_routeT;
}

int Router::getRouterID() const {
    return routerID;
}

void Router::setRouterID(int p_routerID) {
    routerID = p_routerID;
}

int Router::getSenderRouter() const {
    return senderRouter;
}

void Router::setSenderRouter(int p_senderRouter) {
    senderRouter = p_senderRouter;
}

RIPMessagesArray Router::getToSendRIPMessages() const {
    return toSendRIPMessages;
}

void Router::setToSendRIPMessages(RIPMessagesArray p_toSendRIPMessages) {
    toSendRIPMessages = p_toSendRIPMessages;
}

void Router::rootState_entDef() {
    {
        NOTIFY_STATE_ENTERED("ROOT");
        mainState_entDef();
    }
}

IOxfReactive::TakeEventStatus Router::rootState_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    switch (rootState_active) {
        case Initial:
        {
            if(IS_EVENT_TYPE_OF(evInit_Rip_id))
                {
                    OMSETPARAMS(evInit);
                    //## transition 1 
                    if(IS_PORT(pScheduler))
                        {
                            NOTIFY_TRANSITION_STARTED("1");
                            NOTIFY_STATE_EXITED("ROOT.mainState.Initial");
                            //#[ transition 1 
                            
                            routerID= params->id;
                            numberOfInitializationMessagesReceived ++;
                            //#]
                            NOTIFY_STATE_ENTERED("ROOT.mainState.IDReceived");
                            mainState_subState = IDReceived;
                            rootState_active = IDReceived;
                            NOTIFY_TRANSITION_TERMINATED("1");
                            res = eventConsumed;
                        }
                }
            
            
            break;
        }
        case topologyReceived:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("14");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.topologyReceived");
                    CreateInitialTable_entDef();
                    NOTIFY_TRANSITION_TERMINATED("14");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case IDReceived:
        {
            if(IS_EVENT_TYPE_OF(evTopology_Rip_id))
                {
                    OMSETPARAMS(evTopology);
                    //## transition 0 
                    if(IS_PORT(pScheduler))
                        {
                            NOTIFY_TRANSITION_STARTED("0");
                            NOTIFY_STATE_EXITED("ROOT.mainState.IDReceived");
                            //#[ transition 0 
                            
                            neighbours.Array[0] = params->arg1;
                            neighbours.Array[1] = params->arg2;
                            neighbours.Array[2] = params->arg3;
                            countingNumberOfNeighbours();
                            numberOfInitializationMessagesReceived ++;
                            //#]
                            NOTIFY_STATE_ENTERED("ROOT.mainState.topologyReceived");
                            pushNullTransition();
                            mainState_subState = topologyReceived;
                            rootState_active = topologyReceived;
                            NOTIFY_TRANSITION_TERMINATED("0");
                            res = eventConsumed;
                        }
                }
            
            
            break;
        }
        case AckSent:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("4");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.AckSent");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.SendingAndReceivingRIPMessages_ReceivingNewTopology");
                    mainState_subState = SendingAndReceivingRIPMessages_ReceivingNewTopology;
                    rootState_active = SendingAndReceivingRIPMessages_ReceivingNewTopology;
                    NOTIFY_TRANSITION_TERMINATED("4");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case SendingAndReceivingRIPMessages_ReceivingNewTopology:
        {
            res = SendingAndReceivingRIPMessages_ReceivingNewTopology_handleEvent();
            break;
        }
        case RIPMessagesSent:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("7");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.RIPMessagesSent");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.SendingAndReceivingRIPMessages_ReceivingNewTopology");
                    mainState_subState = SendingAndReceivingRIPMessages_ReceivingNewTopology;
                    rootState_active = SendingAndReceivingRIPMessages_ReceivingNewTopology;
                    NOTIFY_TRANSITION_TERMINATED("7");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case TableUpdate_Initial:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.9");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.Initial");
                    //#[ transition ROOT.mainState.TableUpdate.9 
                    n_line = ripMessagesReceived.ArrayNumberOfLines[k -1] ;
                    received_rip = ripMessagesReceived.ArrayRIPMessages[k -1] ;
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CheckingRIPMessage");
                    pushNullTransition();
                    TableUpdate_subState = CheckingRIPMessage;
                    rootState_active = CheckingRIPMessage;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.9");
                    res = eventConsumed;
                }
            
            if(res == eventNotConsumed)
                {
                    res = TableUpdate_handleEvent();
                }
            break;
        }
        case Processing:
        {
            res = Processing_handleEvent();
            break;
        }
        case CheckingNextLine:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.6");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CheckingNextLine");
                    //#[ transition ROOT.mainState.TableUpdate.6 
                    n++;
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.Processing");
                    pushNullTransition();
                    TableUpdate_subState = Processing;
                    rootState_active = Processing;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.6");
                    res = eventConsumed;
                }
            
            if(res == eventNotConsumed)
                {
                    res = TableUpdate_handleEvent();
                }
            break;
        }
        case CheckingRIPMessage:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.2");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CheckingRIPMessage");
                    //#[ transition ROOT.mainState.TableUpdate.2 
                    n = 2;
                    k++ ;
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.Processing");
                    pushNullTransition();
                    TableUpdate_subState = Processing;
                    rootState_active = Processing;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.2");
                    res = eventConsumed;
                }
            
            if(res == eventNotConsumed)
                {
                    res = TableUpdate_handleEvent();
                }
            break;
        }
        case CheckingNextRIPMessage:
        {
            res = CheckingNextRIPMessage_handleEvent();
            break;
        }
        case state_53:
        {
            res = TableUpdate_handleEvent();
            break;
        }
        case SavingSenderRouterID:
        {
            res = SavingSenderRouterID_handleEvent();
            break;
        }
        case CostUpdate_Initial:
        {
            res = CostUpdate_Initial_handleEvent();
            break;
        }
        case Modifying:
        {
            res = Modifying_handleEvent();
            break;
        }
        case ModifyingTheTable:
        {
            res = ModifyingTheTable_handleEvent();
            break;
        }
        case state_59:
        {
            res = state_59_handleEvent();
            break;
        }
        case ChangingTheNextHop:
        {
            res = ChangingTheNextHop_handleEvent();
            break;
        }
        case ModificationComplete:
        {
            res = ModificationComplete_handleEvent();
            break;
        }
        case Adding:
        {
            res = Adding_handleEvent();
            break;
        }
        case state_63:
        {
            res = state_63_handleEvent();
            break;
        }
        case AddingToRoutingTable:
        {
            res = AddingToRoutingTable_handleEvent();
            break;
        }
        case state_65:
        {
            res = state_65_handleEvent();
            break;
        }
        case InitializingCounter:
        {
            res = InitializingCounter_handleEvent();
            break;
        }
        case state_70:
        {
            res = state_70_handleEvent();
            break;
        }
        case RIPMessageReceived:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    //## transition 6 
                    if(numberOfNeighbours ==  numberOfReceivedRIPMessages)
                        {
                            NOTIFY_TRANSITION_STARTED("6");
                            popNullTransition();
                            NOTIFY_STATE_EXITED("ROOT.mainState.RIPMessageReceived");
                            TableUpdate_entDef();
                            NOTIFY_TRANSITION_TERMINATED("6");
                            res = eventConsumed;
                        }
                    else
                        {
                            NOTIFY_TRANSITION_STARTED("11");
                            popNullTransition();
                            NOTIFY_STATE_EXITED("ROOT.mainState.RIPMessageReceived");
                            NOTIFY_STATE_ENTERED("ROOT.mainState.SendingAndReceivingRIPMessages_ReceivingNewTopology");
                            mainState_subState = SendingAndReceivingRIPMessages_ReceivingNewTopology;
                            rootState_active = SendingAndReceivingRIPMessages_ReceivingNewTopology;
                            NOTIFY_TRANSITION_TERMINATED("11");
                            res = eventConsumed;
                        }
                }
            
            
            break;
        }
        case CreateInitialTable_Initial:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateInitialTable.1");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.CreateInitialTable.ROOT.CreateInitialTable.Initial");
                    //#[ transition ROOT.mainState.CreateInitialTable.1 
                    i = 0;
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.CreateInitialTable.ROOT.CreateInitialTable.Start");
                    pushNullTransition();
                    CreateInitialTable_subState = Start;
                    rootState_active = Start;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateInitialTable.1");
                    res = eventConsumed;
                }
            
            if(res == eventNotConsumed)
                {
                    res = CreateInitialTable_handleEvent();
                }
            break;
        }
        case Start:
        {
            res = Start_handleEvent();
            break;
        }
        case SettingInactiveLinks:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateInitialTable.4");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.CreateInitialTable.ROOT.CreateInitialTable.SettingInactiveLinks");
                    //#[ transition ROOT.mainState.CreateInitialTable.4 
                    routeT.ArrayRoutingLine[i].Destination = -neighbours.Array[i] ;
                    routeT.ArrayRoutingLine[i].NextHop = -neighbours.Array[i] ;
                    routeT.ArrayRoutingLine[i].Cost = 16 ;
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.CreateInitialTable.ROOT.CreateInitialTable.TableUpdated");
                    pushNullTransition();
                    CreateInitialTable_subState = TableUpdated;
                    rootState_active = TableUpdated;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateInitialTable.4");
                    res = eventConsumed;
                }
            
            if(res == eventNotConsumed)
                {
                    res = CreateInitialTable_handleEvent();
                }
            break;
        }
        case SettingActiveLinks:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateInitialTable.7");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.CreateInitialTable.ROOT.CreateInitialTable.SettingActiveLinks");
                    //#[ transition ROOT.mainState.CreateInitialTable.7 
                    routeT.ArrayRoutingLine[i].Destination = neighbours.Array[i] ;
                    routeT.ArrayRoutingLine[i].NextHop = neighbours.Array[i] ;
                    routeT.ArrayRoutingLine[i].Cost = 1 ;
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.CreateInitialTable.ROOT.CreateInitialTable.TableUpdated");
                    pushNullTransition();
                    CreateInitialTable_subState = TableUpdated;
                    rootState_active = TableUpdated;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateInitialTable.7");
                    res = eventConsumed;
                }
            
            if(res == eventNotConsumed)
                {
                    res = CreateInitialTable_handleEvent();
                }
            break;
        }
        case TableUpdated:
        {
            res = TableUpdated_handleEvent();
            break;
        }
        case state_31:
        {
            res = CreateInitialTable_handleEvent();
            break;
        }
        case IncrementingTheCounter:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateInitialTable.10");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.CreateInitialTable.ROOT.CreateInitialTable.IncrementingTheCounter");
                    //#[ transition ROOT.mainState.CreateInitialTable.10 
                    i++;
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.CreateInitialTable.ROOT.CreateInitialTable.Start");
                    pushNullTransition();
                    CreateInitialTable_subState = Start;
                    rootState_active = Start;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateInitialTable.10");
                    res = eventConsumed;
                }
            
            if(res == eventNotConsumed)
                {
                    res = CreateInitialTable_handleEvent();
                }
            break;
        }
        case CreateRIPmessage_Initial:
        {
            res = CreateRIPmessage_Initial_handleEvent();
            break;
        }
        case CountersSet:
        {
            res = CountersSet_handleEvent();
            break;
        }
        case AddingItselfToRIPMessage:
        {
            res = AddingItselfToRIPMessage_handleEvent();
            break;
        }
        case AddingLinesToRIPMessage:
        {
            res = AddingLinesToRIPMessage_handleEvent();
            break;
        }
        case OthersAdded:
        {
            res = OthersAdded_handleEvent();
            break;
        }
        case LinesAdded:
        {
            res = LinesAdded_handleEvent();
            break;
        }
        case SendingRIPMessage:
        {
            res = SendingRIPMessage_handleEvent();
            break;
        }
        case state_45:
        {
            res = CreateRIPmessage_handleEvent();
            break;
        }
        case CustomizingEachMessage:
        {
            res = CustomizingEachMessage_handleEvent();
            break;
        }
        case ExcludingLinesOfAParticularReceiver:
        {
            res = ExcludingLinesOfAParticularReceiver_handleEvent();
            break;
        }
        case CreateNewTable_Initial:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateNewTable.1");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.CreateNewTable.ROOT.CreateNewTable.Initial");
                    //#[ transition ROOT.mainState.CreateNewTable.1 
                    i = 0;
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.CreateNewTable.ROOT.CreateNewTable.Start");
                    pushNullTransition();
                    CreateNewTable_subState = CreateNewTable_Start;
                    rootState_active = CreateNewTable_Start;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateNewTable.1");
                    res = eventConsumed;
                }
            
            if(res == eventNotConsumed)
                {
                    res = CreateNewTable_handleEvent();
                }
            break;
        }
        case CreateNewTable_Start:
        {
            res = CreateNewTable_Start_handleEvent();
            break;
        }
        case CreateNewTable_SettingInactiveLinks:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateNewTable.4");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.CreateNewTable.ROOT.CreateNewTable.SettingInactiveLinks");
                    //#[ transition ROOT.mainState.CreateNewTable.4 
                    routeT.ArrayRoutingLine[i].Destination = -neighbours.Array[i] ;
                    routeT.ArrayRoutingLine[i].NextHop = -neighbours.Array[i] ;
                    routeT.ArrayRoutingLine[i].Cost = 16 ;
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.CreateNewTable.ROOT.CreateNewTable.TableUpdated");
                    pushNullTransition();
                    CreateNewTable_subState = CreateNewTable_TableUpdated;
                    rootState_active = CreateNewTable_TableUpdated;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateNewTable.4");
                    res = eventConsumed;
                }
            
            if(res == eventNotConsumed)
                {
                    res = CreateNewTable_handleEvent();
                }
            break;
        }
        case CreateNewTable_SettingActiveLinks:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateNewTable.7");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.CreateNewTable.ROOT.CreateNewTable.SettingActiveLinks");
                    //#[ transition ROOT.mainState.CreateNewTable.7 
                    routeT.ArrayRoutingLine[i].Destination = neighbours.Array[i] ;
                    routeT.ArrayRoutingLine[i].NextHop = neighbours.Array[i] ;
                    routeT.ArrayRoutingLine[i].Cost = 1 ;
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.CreateNewTable.ROOT.CreateNewTable.TableUpdated");
                    pushNullTransition();
                    CreateNewTable_subState = CreateNewTable_TableUpdated;
                    rootState_active = CreateNewTable_TableUpdated;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateNewTable.7");
                    res = eventConsumed;
                }
            
            if(res == eventNotConsumed)
                {
                    res = CreateNewTable_handleEvent();
                }
            break;
        }
        case CreateNewTable_TableUpdated:
        {
            res = CreateNewTable_TableUpdated_handleEvent();
            break;
        }
        case CreateNewTable_state_31:
        {
            res = CreateNewTable_handleEvent();
            break;
        }
        case CreateNewTable_IncrementingTheCounter:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateNewTable.10");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.CreateNewTable.ROOT.CreateNewTable.IncrementingTheCounter");
                    //#[ transition ROOT.mainState.CreateNewTable.10 
                    i++;
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.CreateNewTable.ROOT.CreateNewTable.Start");
                    pushNullTransition();
                    CreateNewTable_subState = CreateNewTable_Start;
                    rootState_active = CreateNewTable_Start;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateNewTable.10");
                    res = eventConsumed;
                }
            
            if(res == eventNotConsumed)
                {
                    res = CreateNewTable_handleEvent();
                }
            break;
        }
        default:
            break;
    }
    return res;
}

void Router::initRelations() {
    pScheduler = newPScheduler();
    pRIP2 = newPRIP2();
    pRIP1 = newPRIP1();
    pRIP3 = newPRIP3();
    pRIP4 = newPRIP4();
    if(getPScheduler())
       getPScheduler()->connectRouter(this);
    if(getPRIP2())
       getPRIP2()->connectRouter(this);
    if(getPRIP1())
       getPRIP1()->connectRouter(this);
    if(getPRIP3())
       getPRIP3()->connectRouter(this);
    if(getPRIP4())
       getPRIP4()->connectRouter(this);
}

void Router::initStatechart() {
    rootState_subState = OMNonState;
    rootState_active = OMNonState;
    mainState_subState = OMNonState;
    TableUpdate_subState = OMNonState;
    CostUpdate_subState = OMNonState;
    CreateRIPmessage_subState = OMNonState;
    CreateNewTable_subState = OMNonState;
    CreateInitialTable_subState = OMNonState;
}

void Router::cleanUpRelations() {
    {
        deletePRIP4();
    }
    {
        deletePRIP3();
    }
    {
        deletePRIP1();
    }
    {
        deletePRIP2();
    }
    {
        deletePScheduler();
    }
}

bool Router::startBehavior() {
    bool done = false;
    done = OMReactive::startBehavior();
    return done;
}

void Router::CreateInitialTable_entDef() {
    NOTIFY_STATE_ENTERED("ROOT.mainState.CreateInitialTable");
    pushNullTransition();
    mainState_subState = CreateInitialTable;
    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateInitialTable.0");
    NOTIFY_STATE_ENTERED("ROOT.mainState.CreateInitialTable.ROOT.CreateInitialTable.Initial");
    pushNullTransition();
    CreateInitialTable_subState = CreateInitialTable_Initial;
    rootState_active = CreateInitialTable_Initial;
    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateInitialTable.0");
}

IOxfReactive::TakeEventStatus Router::AddingItselfToRIPMessage_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            //## transition ROOT.mainState.CreateRIPmessage.3 
            if(routeT.ArrayRoutingLine[ j -1].Destination != 0)
                {
                    //## transition ROOT.mainState.CreateRIPmessage.12 
                    if(routeT.ArrayRoutingLine[ j -1].NextHop != receiverRouterID)
                        {
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateRIPmessage.2");
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateRIPmessage.3");
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateRIPmessage.12");
                            popNullTransition();
                            NOTIFY_STATE_EXITED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.AddingItselfToRIPMessage");
                            NOTIFY_STATE_ENTERED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.ExcludingLinesOfAParticularReceiver");
                            pushNullTransition();
                            CreateRIPmessage_subState = ExcludingLinesOfAParticularReceiver;
                            rootState_active = ExcludingLinesOfAParticularReceiver;
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateRIPmessage.12");
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateRIPmessage.3");
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateRIPmessage.2");
                            res = eventConsumed;
                        }
                    else
                        {
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateRIPmessage.2");
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateRIPmessage.3");
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateRIPmessage.13");
                            popNullTransition();
                            NOTIFY_STATE_EXITED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.AddingItselfToRIPMessage");
                            NOTIFY_STATE_ENTERED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.LinesAdded");
                            pushNullTransition();
                            CreateRIPmessage_subState = LinesAdded;
                            rootState_active = LinesAdded;
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateRIPmessage.13");
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateRIPmessage.3");
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateRIPmessage.2");
                            res = eventConsumed;
                        }
                }
            else
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateRIPmessage.2");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateRIPmessage.5");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.AddingItselfToRIPMessage");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.LinesAdded");
                    pushNullTransition();
                    CreateRIPmessage_subState = LinesAdded;
                    rootState_active = LinesAdded;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateRIPmessage.5");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateRIPmessage.2");
                    res = eventConsumed;
                }
        }
    
    if(res == eventNotConsumed)
        {
            res = CreateRIPmessage_handleEvent();
        }
    return res;
}

IOxfReactive::TakeEventStatus Router::CountersSet_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateRIPmessage.1");
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.CountersSet");
            //#[ transition ROOT.mainState.CreateRIPmessage.1 
            nb_line ++;
            rip_msg.ArrayRIPLine[nb_line -1].Destination = routerID;
            rip_msg.ArrayRIPLine[nb_line -1].Cost = 0;
            //#]
            NOTIFY_STATE_ENTERED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.AddingItselfToRIPMessage");
            pushNullTransition();
            CreateRIPmessage_subState = AddingItselfToRIPMessage;
            rootState_active = AddingItselfToRIPMessage;
            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateRIPmessage.1");
            res = eventConsumed;
        }
    
    if(res == eventNotConsumed)
        {
            res = CreateRIPmessage_handleEvent();
        }
    return res;
}

void Router::CostUpdate_exit() {
    popNullTransition();
    switch (CostUpdate_subState) {
        case CostUpdate_Initial:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.Initial");
            break;
        }
        case Modifying:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.Modifying");
            break;
        }
        case ModifyingTheTable:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.ModifyingTheTable");
            break;
        }
        case state_59:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.state_59");
            break;
        }
        case ChangingTheNextHop:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.ChangingTheNextHop");
            break;
        }
        case ModificationComplete:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.ModificationComplete");
            break;
        }
        case Adding:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.Adding");
            break;
        }
        case state_63:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.state_63");
            break;
        }
        case AddingToRoutingTable:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.AddingToRoutingTable");
            break;
        }
        case state_65:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.state_65");
            break;
        }
        case InitializingCounter:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.InitializingCounter");
            break;
        }
        case state_70:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.state_70");
            break;
        }
        default:
            break;
    }
    CostUpdate_subState = OMNonState;
    NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate");
}

IOxfReactive::TakeEventStatus Router::Processing_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            //## transition ROOT.mainState.TableUpdate.3 
            if(n <= n_line)
                {
                    //## transition ROOT.mainState.TableUpdate.5 
                    if(received_rip.ArrayRIPLine[n -1].Destination == routerID)
                        {
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.1");
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.3");
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.5");
                            popNullTransition();
                            NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.Processing");
                            NOTIFY_STATE_ENTERED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CheckingNextLine");
                            pushNullTransition();
                            TableUpdate_subState = CheckingNextLine;
                            rootState_active = CheckingNextLine;
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.5");
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.3");
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.1");
                            res = eventConsumed;
                        }
                    else
                        {
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.1");
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.3");
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.7");
                            popNullTransition();
                            NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.Processing");
                            NOTIFY_STATE_ENTERED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.SavingSenderRouterID");
                            pushNullTransition();
                            TableUpdate_subState = SavingSenderRouterID;
                            rootState_active = SavingSenderRouterID;
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.7");
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.3");
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.1");
                            res = eventConsumed;
                        }
                }
            else
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.1");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.4");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.Processing");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CheckingNextRIPMessage");
                    pushNullTransition();
                    TableUpdate_subState = CheckingNextRIPMessage;
                    rootState_active = CheckingNextRIPMessage;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.4");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.1");
                    res = eventConsumed;
                }
        }
    
    if(res == eventNotConsumed)
        {
            res = TableUpdate_handleEvent();
        }
    return res;
}

void Router::CreateRIPmessage_exit() {
    popNullTransition();
    switch (CreateRIPmessage_subState) {
        case CreateRIPmessage_Initial:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.Initial");
            break;
        }
        case CountersSet:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.CountersSet");
            break;
        }
        case AddingItselfToRIPMessage:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.AddingItselfToRIPMessage");
            break;
        }
        case AddingLinesToRIPMessage:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.AddingLinesToRIPMessage");
            break;
        }
        case OthersAdded:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.OthersAdded");
            break;
        }
        case LinesAdded:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.LinesAdded");
            break;
        }
        case SendingRIPMessage:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.SendingRIPMessage");
            break;
        }
        case state_45:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.state_45");
            break;
        }
        case CustomizingEachMessage:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.CustomizingEachMessage");
            break;
        }
        case ExcludingLinesOfAParticularReceiver:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.ExcludingLinesOfAParticularReceiver");
            break;
        }
        default:
            break;
    }
    CreateRIPmessage_subState = OMNonState;
    NOTIFY_STATE_EXITED("ROOT.mainState.CreateRIPmessage");
}

IOxfReactive::TakeEventStatus Router::ChangingTheNextHop_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            //## transition ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.12 
            if(cost >= 15)
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.11");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.12");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.ChangingTheNextHop");
                    //#[ transition ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.12 
                    
                    routeT.ArrayRoutingLine[m-1].Cost = 16 ;
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.ModificationComplete");
                    pushNullTransition();
                    CostUpdate_subState = ModificationComplete;
                    rootState_active = ModificationComplete;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.12");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.11");
                    res = eventConsumed;
                }
            else
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.11");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.13");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.ChangingTheNextHop");
                    //#[ transition ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.13 
                    
                    routeT.ArrayRoutingLine[m-1].Cost = cost +1 ;
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.ModificationComplete");
                    pushNullTransition();
                    CostUpdate_subState = ModificationComplete;
                    rootState_active = ModificationComplete;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.13");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.11");
                    res = eventConsumed;
                }
        }
    
    if(res == eventNotConsumed)
        {
            res = CostUpdate_handleEvent();
        }
    return res;
}

IOxfReactive::TakeEventStatus Router::state_59_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    res = CostUpdate_handleEvent();
    return res;
}

void Router::mainState_entDef() {
    NOTIFY_STATE_ENTERED("ROOT.mainState");
    rootState_subState = mainState;
    NOTIFY_TRANSITION_STARTED("2");
    NOTIFY_STATE_ENTERED("ROOT.mainState.Initial");
    mainState_subState = Initial;
    rootState_active = Initial;
    NOTIFY_TRANSITION_TERMINATED("2");
}

IOxfReactive::TakeEventStatus Router::CreateNewTable_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            //## transition 13 
            if(IS_COMPLETED(CreateNewTable))
                {
                    NOTIFY_TRANSITION_STARTED("13");
                    CreateNewTable_exit();
                    NOTIFY_STATE_ENTERED("ROOT.mainState.SendingAndReceivingRIPMessages_ReceivingNewTopology");
                    mainState_subState = SendingAndReceivingRIPMessages_ReceivingNewTopology;
                    rootState_active = SendingAndReceivingRIPMessages_ReceivingNewTopology;
                    NOTIFY_TRANSITION_TERMINATED("13");
                    res = eventConsumed;
                }
        }
    
    
    return res;
}

IOxfReactive::TakeEventStatus Router::Adding_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            //## transition ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.16 
            if(routeT.ArrayRoutingLine[m-1].Destination == 0)
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.19");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.16");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.Adding");
                    //#[ transition ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.16 
                    
                    routeT.ArrayRoutingLine[m-1].Destination = dest;
                    routeT.ArrayRoutingLine[m-1].NextHop = next;
                    routeT.ArrayRoutingLine[m-1].Cost = cost +1 ;
                    numberOfNeighbours++ ;
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.AddingToRoutingTable");
                    pushNullTransition();
                    CostUpdate_subState = AddingToRoutingTable;
                    rootState_active = AddingToRoutingTable;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.16");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.19");
                    res = eventConsumed;
                }
            else
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.19");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.17");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.Adding");
                    //#[ transition ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.17 
                    m++;
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.Adding");
                    pushNullTransition();
                    CostUpdate_subState = Adding;
                    rootState_active = Adding;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.17");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.19");
                    res = eventConsumed;
                }
        }
    
    if(res == eventNotConsumed)
        {
            res = CostUpdate_handleEvent();
        }
    return res;
}

IOxfReactive::TakeEventStatus Router::Modifying_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            //## transition ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.8 
            if(routeT.ArrayRoutingLine[m-1].Cost > (cost +1))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.7");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.8");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.Modifying");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.ModifyingTheTable");
                    pushNullTransition();
                    CostUpdate_subState = ModifyingTheTable;
                    rootState_active = ModifyingTheTable;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.8");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.7");
                    res = eventConsumed;
                }
            else
                {
                    //## transition ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.21 
                    if(routeT.ArrayRoutingLine[m-1].NextHop == next)
                        {
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.7");
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.21");
                            popNullTransition();
                            NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.Modifying");
                            NOTIFY_STATE_ENTERED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.ModifyingTheTable");
                            pushNullTransition();
                            CostUpdate_subState = ModifyingTheTable;
                            rootState_active = ModifyingTheTable;
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.21");
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.7");
                            res = eventConsumed;
                        }
                    else
                        {
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.7");
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.9");
                            popNullTransition();
                            NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.Modifying");
                            NOTIFY_STATE_ENTERED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.state_59");
                            CostUpdate_subState = state_59;
                            rootState_active = state_59;
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.9");
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.7");
                            res = eventConsumed;
                        }
                }
        }
    
    if(res == eventNotConsumed)
        {
            res = CostUpdate_handleEvent();
        }
    return res;
}

IOxfReactive::TakeEventStatus Router::state_63_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    res = CostUpdate_handleEvent();
    return res;
}

IOxfReactive::TakeEventStatus Router::state_70_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    res = CostUpdate_handleEvent();
    return res;
}

void Router::TableUpdate_exit() {
    popNullTransition();
    switch (TableUpdate_subState) {
        case TableUpdate_Initial:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.Initial");
            break;
        }
        case Processing:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.Processing");
            break;
        }
        case CheckingNextLine:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CheckingNextLine");
            break;
        }
        case CheckingRIPMessage:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CheckingRIPMessage");
            break;
        }
        case CheckingNextRIPMessage:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CheckingNextRIPMessage");
            break;
        }
        case state_53:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.state_53");
            break;
        }
        case SavingSenderRouterID:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.SavingSenderRouterID");
            break;
        }
        case CostUpdate:
        {
            CostUpdate_exit();
            break;
        }
        default:
            break;
    }
    TableUpdate_subState = OMNonState;
    NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate");
}

void Router::TableUpdate_entDef() {
    NOTIFY_STATE_ENTERED("ROOT.mainState.TableUpdate");
    pushNullTransition();
    mainState_subState = TableUpdate;
    NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.0");
    //#[ transition ROOT.mainState.TableUpdate.0 
    k = 1;
    //#]
    NOTIFY_STATE_ENTERED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.Initial");
    pushNullTransition();
    TableUpdate_subState = TableUpdate_Initial;
    rootState_active = TableUpdate_Initial;
    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.0");
}

IOxfReactive::TakeEventStatus Router::Start_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            //## transition ROOT.mainState.CreateInitialTable.2 
            if(neighbours.Array[i] < 0)
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateInitialTable.9");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateInitialTable.2");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.CreateInitialTable.ROOT.CreateInitialTable.Start");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.CreateInitialTable.ROOT.CreateInitialTable.SettingInactiveLinks");
                    pushNullTransition();
                    CreateInitialTable_subState = SettingInactiveLinks;
                    rootState_active = SettingInactiveLinks;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateInitialTable.2");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateInitialTable.9");
                    res = eventConsumed;
                }
            else
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateInitialTable.9");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateInitialTable.3");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.CreateInitialTable.ROOT.CreateInitialTable.Start");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.CreateInitialTable.ROOT.CreateInitialTable.SettingActiveLinks");
                    pushNullTransition();
                    CreateInitialTable_subState = SettingActiveLinks;
                    rootState_active = SettingActiveLinks;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateInitialTable.3");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateInitialTable.9");
                    res = eventConsumed;
                }
        }
    
    if(res == eventNotConsumed)
        {
            res = CreateInitialTable_handleEvent();
        }
    return res;
}

IOxfReactive::TakeEventStatus Router::TableUpdated_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            //## transition ROOT.mainState.CreateInitialTable.8 
            if(i < (NbNodes - 2))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateInitialTable.5");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateInitialTable.8");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.CreateInitialTable.ROOT.CreateInitialTable.TableUpdated");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.CreateInitialTable.ROOT.CreateInitialTable.IncrementingTheCounter");
                    pushNullTransition();
                    CreateInitialTable_subState = IncrementingTheCounter;
                    rootState_active = IncrementingTheCounter;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateInitialTable.8");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateInitialTable.5");
                    res = eventConsumed;
                }
            else
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateInitialTable.5");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateInitialTable.6");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.CreateInitialTable.ROOT.CreateInitialTable.TableUpdated");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.CreateInitialTable.ROOT.CreateInitialTable.state_31");
                    CreateInitialTable_subState = state_31;
                    rootState_active = state_31;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateInitialTable.6");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateInitialTable.5");
                    res = eventConsumed;
                }
        }
    
    if(res == eventNotConsumed)
        {
            res = CreateInitialTable_handleEvent();
        }
    return res;
}

IOxfReactive::TakeEventStatus Router::CreateNewTable_Start_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            //## transition ROOT.mainState.CreateNewTable.2 
            if(neighbours.Array[i] < 0)
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateNewTable.9");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateNewTable.2");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.CreateNewTable.ROOT.CreateNewTable.Start");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.CreateNewTable.ROOT.CreateNewTable.SettingInactiveLinks");
                    pushNullTransition();
                    CreateNewTable_subState = CreateNewTable_SettingInactiveLinks;
                    rootState_active = CreateNewTable_SettingInactiveLinks;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateNewTable.2");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateNewTable.9");
                    res = eventConsumed;
                }
            else
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateNewTable.9");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateNewTable.3");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.CreateNewTable.ROOT.CreateNewTable.Start");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.CreateNewTable.ROOT.CreateNewTable.SettingActiveLinks");
                    pushNullTransition();
                    CreateNewTable_subState = CreateNewTable_SettingActiveLinks;
                    rootState_active = CreateNewTable_SettingActiveLinks;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateNewTable.3");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateNewTable.9");
                    res = eventConsumed;
                }
        }
    
    if(res == eventNotConsumed)
        {
            res = CreateNewTable_handleEvent();
        }
    return res;
}

IOxfReactive::TakeEventStatus Router::CustomizingEachMessage_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateRIPmessage.11");
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.CustomizingEachMessage");
            //#[ transition ROOT.mainState.CreateRIPmessage.11 
            receiverRouterID =1;
            //#]
            NOTIFY_STATE_ENTERED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.Initial");
            pushNullTransition();
            CreateRIPmessage_subState = CreateRIPmessage_Initial;
            rootState_active = CreateRIPmessage_Initial;
            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateRIPmessage.11");
            res = eventConsumed;
        }
    
    if(res == eventNotConsumed)
        {
            res = CreateRIPmessage_handleEvent();
        }
    return res;
}

IOxfReactive::TakeEventStatus Router::AddingLinesToRIPMessage_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateRIPmessage.4");
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.AddingLinesToRIPMessage");
            //#[ transition ROOT.mainState.CreateRIPmessage.4 
            nb_line++;
            rip_msg.ArrayRIPLine[nb_line -1].Destination = routeT.ArrayRoutingLine[ j -1].Destination ;
            rip_msg.ArrayRIPLine[nb_line -1].Cost = routeT.ArrayRoutingLine[ j -1].Cost ;
            //#]
            NOTIFY_STATE_ENTERED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.OthersAdded");
            pushNullTransition();
            CreateRIPmessage_subState = OthersAdded;
            rootState_active = OthersAdded;
            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateRIPmessage.4");
            res = eventConsumed;
        }
    
    if(res == eventNotConsumed)
        {
            res = CreateRIPmessage_handleEvent();
        }
    return res;
}

IOxfReactive::TakeEventStatus Router::ExcludingLinesOfAParticularReceiver_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateRIPmessage.15");
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.ExcludingLinesOfAParticularReceiver");
            NOTIFY_STATE_ENTERED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.AddingLinesToRIPMessage");
            pushNullTransition();
            CreateRIPmessage_subState = AddingLinesToRIPMessage;
            rootState_active = AddingLinesToRIPMessage;
            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateRIPmessage.15");
            res = eventConsumed;
        }
    
    if(res == eventNotConsumed)
        {
            res = CreateRIPmessage_handleEvent();
        }
    return res;
}

IOxfReactive::TakeEventStatus Router::OthersAdded_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateRIPmessage.6");
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.OthersAdded");
            NOTIFY_STATE_ENTERED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.LinesAdded");
            pushNullTransition();
            CreateRIPmessage_subState = LinesAdded;
            rootState_active = LinesAdded;
            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateRIPmessage.6");
            res = eventConsumed;
        }
    
    if(res == eventNotConsumed)
        {
            res = CreateRIPmessage_handleEvent();
        }
    return res;
}

IOxfReactive::TakeEventStatus Router::CostUpdate_Initial_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            res = CostUpdate_InitialTakeNull();
        }
    
    if(res == eventNotConsumed)
        {
            res = CostUpdate_handleEvent();
        }
    return res;
}

IOxfReactive::TakeEventStatus Router::SavingSenderRouterID_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            //## transition ROOT.mainState.TableUpdate.13 
            if(received_rip.ArrayRIPLine[0].Cost == 0)
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.13");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.SavingSenderRouterID");
                    //#[ transition ROOT.mainState.TableUpdate.13 
                    
                    senderRouter = received_rip.ArrayRIPLine[0].Destination;
                    //#]
                    CostUpdate_entDef();
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.13");
                    res = eventConsumed;
                }
        }
    
    if(res == eventNotConsumed)
        {
            res = TableUpdate_handleEvent();
        }
    return res;
}

IOxfReactive::TakeEventStatus Router::TableUpdate_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            //## transition 12 
            if(IS_COMPLETED(TableUpdate))
                {
                    NOTIFY_TRANSITION_STARTED("12");
                    TableUpdate_exit();
                    //#[ transition 12 
                    numberOfReceivedRIPMessages = 0;
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.SendingAndReceivingRIPMessages_ReceivingNewTopology");
                    mainState_subState = SendingAndReceivingRIPMessages_ReceivingNewTopology;
                    rootState_active = SendingAndReceivingRIPMessages_ReceivingNewTopology;
                    NOTIFY_TRANSITION_TERMINATED("12");
                    res = eventConsumed;
                }
        }
    
    
    return res;
}

IOxfReactive::TakeEventStatus Router::CreateNewTable_TableUpdated_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            //## transition ROOT.mainState.CreateNewTable.8 
            if(i < (NbNodes - 2))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateNewTable.5");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateNewTable.8");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.CreateNewTable.ROOT.CreateNewTable.TableUpdated");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.CreateNewTable.ROOT.CreateNewTable.IncrementingTheCounter");
                    pushNullTransition();
                    CreateNewTable_subState = CreateNewTable_IncrementingTheCounter;
                    rootState_active = CreateNewTable_IncrementingTheCounter;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateNewTable.8");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateNewTable.5");
                    res = eventConsumed;
                }
            else
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateNewTable.5");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateNewTable.6");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.CreateNewTable.ROOT.CreateNewTable.TableUpdated");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.CreateNewTable.ROOT.CreateNewTable.state_31");
                    CreateNewTable_subState = CreateNewTable_state_31;
                    rootState_active = CreateNewTable_state_31;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateNewTable.6");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateNewTable.5");
                    res = eventConsumed;
                }
        }
    
    if(res == eventNotConsumed)
        {
            res = CreateNewTable_handleEvent();
        }
    return res;
}

void Router::CreateNewTable_entDef() {
    NOTIFY_STATE_ENTERED("ROOT.mainState.CreateNewTable");
    pushNullTransition();
    mainState_subState = CreateNewTable;
    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateNewTable.0");
    NOTIFY_STATE_ENTERED("ROOT.mainState.CreateNewTable.ROOT.CreateNewTable.Initial");
    pushNullTransition();
    CreateNewTable_subState = CreateNewTable_Initial;
    rootState_active = CreateNewTable_Initial;
    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateNewTable.0");
}

IOxfReactive::TakeEventStatus Router::SendingRIPMessage_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            //## transition ROOT.mainState.CreateRIPmessage.16 
            if(receiverRouterID > 4)
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateRIPmessage.17");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateRIPmessage.16");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.SendingRIPMessage");
                    //#[ transition ROOT.mainState.CreateRIPmessage.17 
                    switch (receiverRouterID)
                    {
                    case 1:
                    toSendRIPMessages.Array[0] =rip_msg;
                    toSendRIPMessages.ArrayNbLine[0] = nb_line ;
                    break;
                    case 2:
                    toSendRIPMessages.Array[1] =rip_msg;
                    toSendRIPMessages.ArrayNbLine[1] = nb_line ;
                    break;
                    case 3:
                    toSendRIPMessages.Array[2] =rip_msg;
                    toSendRIPMessages.ArrayNbLine[2] = nb_line ;
                    break;
                    case 4:
                    toSendRIPMessages.Array[3] =rip_msg;
                    toSendRIPMessages.ArrayNbLine[3] = nb_line ;
                    break;
                    }
                    receiverRouterID++;
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.state_45");
                    CreateRIPmessage_subState = state_45;
                    rootState_active = state_45;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateRIPmessage.16");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateRIPmessage.17");
                    res = eventConsumed;
                }
            else
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateRIPmessage.17");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateRIPmessage.18");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.SendingRIPMessage");
                    //#[ transition ROOT.mainState.CreateRIPmessage.17 
                    switch (receiverRouterID)
                    {
                    case 1:
                    toSendRIPMessages.Array[0] =rip_msg;
                    toSendRIPMessages.ArrayNbLine[0] = nb_line ;
                    break;
                    case 2:
                    toSendRIPMessages.Array[1] =rip_msg;
                    toSendRIPMessages.ArrayNbLine[1] = nb_line ;
                    break;
                    case 3:
                    toSendRIPMessages.Array[2] =rip_msg;
                    toSendRIPMessages.ArrayNbLine[2] = nb_line ;
                    break;
                    case 4:
                    toSendRIPMessages.Array[3] =rip_msg;
                    toSendRIPMessages.ArrayNbLine[3] = nb_line ;
                    break;
                    }
                    receiverRouterID++;
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.Initial");
                    pushNullTransition();
                    CreateRIPmessage_subState = CreateRIPmessage_Initial;
                    rootState_active = CreateRIPmessage_Initial;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateRIPmessage.18");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateRIPmessage.17");
                    res = eventConsumed;
                }
        }
    
    if(res == eventNotConsumed)
        {
            res = CreateRIPmessage_handleEvent();
        }
    return res;
}

void Router::CreateRIPmessage_entDef() {
    NOTIFY_STATE_ENTERED("ROOT.mainState.CreateRIPmessage");
    pushNullTransition();
    mainState_subState = CreateRIPmessage;
    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateRIPmessage.10");
    NOTIFY_STATE_ENTERED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.CustomizingEachMessage");
    pushNullTransition();
    CreateRIPmessage_subState = CustomizingEachMessage;
    rootState_active = CustomizingEachMessage;
    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateRIPmessage.10");
}

IOxfReactive::TakeEventStatus Router::InitializingCounter_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.20");
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.InitializingCounter");
            //#[ transition ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.20 
            m =1;
            //#]
            NOTIFY_STATE_ENTERED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.Adding");
            pushNullTransition();
            CostUpdate_subState = Adding;
            rootState_active = Adding;
            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.20");
            res = eventConsumed;
        }
    
    if(res == eventNotConsumed)
        {
            res = CostUpdate_handleEvent();
        }
    return res;
}

IOxfReactive::TakeEventStatus Router::CreateRIPmessage_Initial_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateRIPmessage.0");
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.Initial");
            //#[ transition ROOT.mainState.CreateRIPmessage.0 
            j = 1;
            nb_line = 0;
            //#]
            NOTIFY_STATE_ENTERED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.CountersSet");
            pushNullTransition();
            CreateRIPmessage_subState = CountersSet;
            rootState_active = CountersSet;
            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateRIPmessage.0");
            res = eventConsumed;
        }
    
    if(res == eventNotConsumed)
        {
            res = CreateRIPmessage_handleEvent();
        }
    return res;
}

IOxfReactive::TakeEventStatus Router::LinesAdded_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            //## transition ROOT.mainState.CreateRIPmessage.8 
            if(j >= (NbNodes-1))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateRIPmessage.7");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateRIPmessage.8");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.LinesAdded");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.SendingRIPMessage");
                    pushNullTransition();
                    CreateRIPmessage_subState = SendingRIPMessage;
                    rootState_active = SendingRIPMessage;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateRIPmessage.8");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateRIPmessage.7");
                    res = eventConsumed;
                }
            else
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateRIPmessage.7");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.CreateRIPmessage.9");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.LinesAdded");
                    //#[ transition ROOT.mainState.CreateRIPmessage.9 
                    j++;
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.AddingItselfToRIPMessage");
                    pushNullTransition();
                    CreateRIPmessage_subState = AddingItselfToRIPMessage;
                    rootState_active = AddingItselfToRIPMessage;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateRIPmessage.9");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.CreateRIPmessage.7");
                    res = eventConsumed;
                }
        }
    
    if(res == eventNotConsumed)
        {
            res = CreateRIPmessage_handleEvent();
        }
    return res;
}

IOxfReactive::TakeEventStatus Router::CreateRIPmessage_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            //## transition 5 
            if(IS_COMPLETED(CreateRIPmessage))
                {
                    NOTIFY_TRANSITION_STARTED("5");
                    CreateRIPmessage_exit();
                    //#[ transition 5 
                    send_RIPtable();
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.RIPMessagesSent");
                    pushNullTransition();
                    mainState_subState = RIPMessagesSent;
                    rootState_active = RIPMessagesSent;
                    NOTIFY_TRANSITION_TERMINATED("5");
                    res = eventConsumed;
                }
        }
    
    
    return res;
}

void Router::CreateNewTable_exit() {
    popNullTransition();
    switch (CreateNewTable_subState) {
        case CreateNewTable_Initial:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.CreateNewTable.ROOT.CreateNewTable.Initial");
            break;
        }
        case CreateNewTable_Start:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.CreateNewTable.ROOT.CreateNewTable.Start");
            break;
        }
        case CreateNewTable_SettingInactiveLinks:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.CreateNewTable.ROOT.CreateNewTable.SettingInactiveLinks");
            break;
        }
        case CreateNewTable_SettingActiveLinks:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.CreateNewTable.ROOT.CreateNewTable.SettingActiveLinks");
            break;
        }
        case CreateNewTable_TableUpdated:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.CreateNewTable.ROOT.CreateNewTable.TableUpdated");
            break;
        }
        case CreateNewTable_state_31:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.CreateNewTable.ROOT.CreateNewTable.state_31");
            break;
        }
        case CreateNewTable_IncrementingTheCounter:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.CreateNewTable.ROOT.CreateNewTable.IncrementingTheCounter");
            break;
        }
        default:
            break;
    }
    CreateNewTable_subState = OMNonState;
    NOTIFY_STATE_EXITED("ROOT.mainState.CreateNewTable");
}

IOxfReactive::TakeEventStatus Router::CheckingNextRIPMessage_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            //## transition ROOT.mainState.TableUpdate.12 
            if(k > numberOfReceivedRIPMessages)
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.10");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.12");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CheckingNextRIPMessage");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.state_53");
                    TableUpdate_subState = state_53;
                    rootState_active = state_53;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.12");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.10");
                    res = eventConsumed;
                }
            else
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.10");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.11");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CheckingNextRIPMessage");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.Initial");
                    pushNullTransition();
                    TableUpdate_subState = TableUpdate_Initial;
                    rootState_active = TableUpdate_Initial;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.11");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.10");
                    res = eventConsumed;
                }
        }
    
    if(res == eventNotConsumed)
        {
            res = TableUpdate_handleEvent();
        }
    return res;
}

IOxfReactive::TakeEventStatus Router::CreateInitialTable_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            //## transition 3 
            if(numberOfInitializationMessagesReceived == 2 && IS_COMPLETED(CreateInitialTable))
                {
                    NOTIFY_TRANSITION_STARTED("3");
                    CreateInitialTable_exit();
                    //#[ transition 3 
                    
                    OUT_PORT(pScheduler)->GEN(evRep_Init);
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.AckSent");
                    pushNullTransition();
                    mainState_subState = AckSent;
                    rootState_active = AckSent;
                    NOTIFY_TRANSITION_TERMINATED("3");
                    res = eventConsumed;
                }
        }
    
    
    return res;
}

void Router::CreateInitialTable_exit() {
    popNullTransition();
    switch (CreateInitialTable_subState) {
        case CreateInitialTable_Initial:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.CreateInitialTable.ROOT.CreateInitialTable.Initial");
            break;
        }
        case Start:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.CreateInitialTable.ROOT.CreateInitialTable.Start");
            break;
        }
        case SettingInactiveLinks:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.CreateInitialTable.ROOT.CreateInitialTable.SettingInactiveLinks");
            break;
        }
        case SettingActiveLinks:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.CreateInitialTable.ROOT.CreateInitialTable.SettingActiveLinks");
            break;
        }
        case TableUpdated:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.CreateInitialTable.ROOT.CreateInitialTable.TableUpdated");
            break;
        }
        case state_31:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.CreateInitialTable.ROOT.CreateInitialTable.state_31");
            break;
        }
        case IncrementingTheCounter:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.CreateInitialTable.ROOT.CreateInitialTable.IncrementingTheCounter");
            break;
        }
        default:
            break;
    }
    CreateInitialTable_subState = OMNonState;
    NOTIFY_STATE_EXITED("ROOT.mainState.CreateInitialTable");
}

IOxfReactive::TakeEventStatus Router::state_65_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    res = CostUpdate_handleEvent();
    return res;
}

IOxfReactive::TakeEventStatus Router::SendingAndReceivingRIPMessages_ReceivingNewTopology_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(evTimer_Rip_id))
        {
            OMSETPARAMS(evTimer);
            NOTIFY_TRANSITION_STARTED("15");
            NOTIFY_STATE_EXITED("ROOT.mainState.SendingAndReceivingRIPMessages_ReceivingNewTopology");
            CreateRIPmessage_entDef();
            NOTIFY_TRANSITION_TERMINATED("15");
            res = eventConsumed;
        }
    else if(IS_EVENT_TYPE_OF(evRIP_Rip_id))
        {
            OMSETPARAMS(evRIP);
            NOTIFY_TRANSITION_STARTED("10");
            NOTIFY_STATE_EXITED("ROOT.mainState.SendingAndReceivingRIPMessages_ReceivingNewTopology");
            //#[ transition 10 
            
            ripMessagesReceived.ArrayNumberOfLines[numberOfReceivedRIPMessages] = params->NBLines;
            ripMessagesReceived.ArrayRIPMessages[numberOfReceivedRIPMessages] = params->msg;
            numberOfReceivedRIPMessages ++;
            //#]
            NOTIFY_STATE_ENTERED("ROOT.mainState.RIPMessageReceived");
            pushNullTransition();
            mainState_subState = RIPMessageReceived;
            rootState_active = RIPMessageReceived;
            NOTIFY_TRANSITION_TERMINATED("10");
            res = eventConsumed;
        }
    else if(IS_EVENT_TYPE_OF(evTopology_Rip_id))
        {
            OMSETPARAMS(evTopology);
            //## transition 8 
            if(IS_PORT(pScheduler))
                {
                    NOTIFY_TRANSITION_STARTED("8");
                    NOTIFY_STATE_EXITED("ROOT.mainState.SendingAndReceivingRIPMessages_ReceivingNewTopology");
                    //#[ transition 8 
                    
                    neighbours.Array[0] = params->arg1;
                    neighbours.Array[1] = params->arg2;
                    neighbours.Array[2] = params->arg3;
                    countingNumberOfNeighbours();
                    numberOfReceivedRIPMessages = 0;
                    //#]
                    CreateNewTable_entDef();
                    NOTIFY_TRANSITION_TERMINATED("8");
                    res = eventConsumed;
                }
        }
    
    
    return res;
}

IOxfReactive::TakeEventStatus Router::CostUpdate_InitialTakeNull() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    //## transition ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.3 
    if(routeT.ArrayRoutingLine[m-1].Destination == dest)
        {
            NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.1");
            NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.3");
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.Initial");
            NOTIFY_STATE_ENTERED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.Modifying");
            pushNullTransition();
            CostUpdate_subState = Modifying;
            rootState_active = Modifying;
            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.3");
            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.1");
            res = eventConsumed;
        }
    else
        {
            //## transition ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.5 
            if(( m +1 ) > NbNodes)
                {
                    //## transition ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.22 
                    if(numberOfNeighbours == (NbNodes -1))
                        {
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.1");
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.2");
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.5");
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.22");
                            popNullTransition();
                            NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.Initial");
                            //#[ transition ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.2 
                            
                            m++;
                            //#]
                            NOTIFY_STATE_ENTERED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.state_70");
                            CostUpdate_subState = state_70;
                            rootState_active = state_70;
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.22");
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.5");
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.2");
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.1");
                            res = eventConsumed;
                        }
                    else
                        {
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.1");
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.2");
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.5");
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.23");
                            popNullTransition();
                            NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.Initial");
                            //#[ transition ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.2 
                            
                            m++;
                            //#]
                            NOTIFY_STATE_ENTERED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.InitializingCounter");
                            pushNullTransition();
                            CostUpdate_subState = InitializingCounter;
                            rootState_active = InitializingCounter;
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.23");
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.5");
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.2");
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.1");
                            res = eventConsumed;
                        }
                }
            else
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.1");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.2");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.4");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.Initial");
                    //#[ transition ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.2 
                    
                    m++;
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.Initial");
                    pushNullTransition();
                    CostUpdate_subState = CostUpdate_Initial;
                    rootState_active = CostUpdate_Initial;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.4");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.2");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.1");
                    res = eventConsumed;
                }
        }
    return res;
}

IOxfReactive::TakeEventStatus Router::ModificationComplete_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.15");
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.ModificationComplete");
            NOTIFY_STATE_ENTERED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.state_63");
            CostUpdate_subState = state_63;
            rootState_active = state_63;
            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.15");
            res = eventConsumed;
        }
    
    if(res == eventNotConsumed)
        {
            res = CostUpdate_handleEvent();
        }
    return res;
}

IOxfReactive::TakeEventStatus Router::ModifyingTheTable_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.10");
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.ModifyingTheTable");
            //#[ transition ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.10 
            routeT.ArrayRoutingLine[m-1].NextHop = next ;
            //#]
            NOTIFY_STATE_ENTERED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.ChangingTheNextHop");
            pushNullTransition();
            CostUpdate_subState = ChangingTheNextHop;
            rootState_active = ChangingTheNextHop;
            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.10");
            res = eventConsumed;
        }
    
    if(res == eventNotConsumed)
        {
            res = CostUpdate_handleEvent();
        }
    return res;
}

IOxfReactive::TakeEventStatus Router::AddingToRoutingTable_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.18");
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.AddingToRoutingTable");
            NOTIFY_STATE_ENTERED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.state_65");
            CostUpdate_subState = state_65;
            rootState_active = state_65;
            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.18");
            res = eventConsumed;
        }
    
    if(res == eventNotConsumed)
        {
            res = CostUpdate_handleEvent();
        }
    return res;
}

IOxfReactive::TakeEventStatus Router::CostUpdate_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            //## transition ROOT.mainState.TableUpdate.8 
            if(IS_COMPLETED(CostUpdate))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.8");
                    CostUpdate_exit();
                    NOTIFY_STATE_ENTERED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CheckingNextLine");
                    pushNullTransition();
                    TableUpdate_subState = CheckingNextLine;
                    rootState_active = CheckingNextLine;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.8");
                    res = eventConsumed;
                }
        }
    
    if(res == eventNotConsumed)
        {
            res = TableUpdate_handleEvent();
        }
    return res;
}

void Router::CostUpdate_entDef() {
    NOTIFY_STATE_ENTERED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate");
    pushNullTransition();
    TableUpdate_subState = CostUpdate;
    NOTIFY_TRANSITION_STARTED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.0");
    //#[ transition ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.0 
    dest = received_rip.ArrayRIPLine[n -1].Destination ; 
    next = senderRouter ;
    cost = received_rip.ArrayRIPLine[n-1].Cost ;
    m = 1;
    //#]
    NOTIFY_STATE_ENTERED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.Initial");
    pushNullTransition();
    CostUpdate_subState = CostUpdate_Initial;
    rootState_active = CostUpdate_Initial;
    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.0");
}

void Router::mainState_exit() {
    switch (mainState_subState) {
        case Initial:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.Initial");
            break;
        }
        case topologyReceived:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.topologyReceived");
            break;
        }
        case IDReceived:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.IDReceived");
            break;
        }
        case AckSent:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.AckSent");
            break;
        }
        case SendingAndReceivingRIPMessages_ReceivingNewTopology:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.SendingAndReceivingRIPMessages_ReceivingNewTopology");
            break;
        }
        case RIPMessagesSent:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.RIPMessagesSent");
            break;
        }
        case TableUpdate:
        {
            TableUpdate_exit();
            break;
        }
        case RIPMessageReceived:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.RIPMessageReceived");
            break;
        }
        case CreateInitialTable:
        {
            CreateInitialTable_exit();
            break;
        }
        case CreateRIPmessage:
        {
            CreateRIPmessage_exit();
            break;
        }
        case CreateNewTable:
        {
            CreateNewTable_exit();
            break;
        }
        default:
            break;
    }
    mainState_subState = OMNonState;
    NOTIFY_STATE_EXITED("ROOT.mainState");
}





Router::pScheduler_C::pScheduler_C() {
    initRelations();
}

Router::pScheduler_C::~pScheduler_C() {
}

void Router::pScheduler_C::connectRouter(Router* part) {
    //#[ operation connectRouter(Router*) 
    InBound.setItsISchedulerRouter3(part);
    InBound.setPort(this); // for IS_PORT macro support
    
    //#]
}

iRouterScheduler1* Router::pScheduler_C::getItsIRouterScheduler1() {
    //#[ operation getItsIRouterScheduler1() 
    return &OutBound;
    //#]
}

iSchedulerRouter3* Router::pScheduler_C::getItsISchedulerRouter3() {
    //#[ operation getItsISchedulerRouter3() 
    return &InBound;
    //#]
}

void Router::pScheduler_C::setItsIRouterScheduler1(OMReactive* p_iRouterScheduler1) {
    //#[ operation setItsIRouterScheduler1(OMReactive*) 
    OutBound.setItsIRouterScheduler1(p_iRouterScheduler1);
    //#]
}

void Router::pScheduler_C::setItsISchedulerRouter3(iSchedulerRouter3* p_iSchedulerRouter3) {
    //#[ operation setItsISchedulerRouter3(iSchedulerRouter3*) 
    InBound.setItsISchedulerRouter3(p_iSchedulerRouter3);
    //#]
}

Router::pScheduler_C::InBound_C* Router::pScheduler_C::getInBound() const {
    return (Router::pScheduler_C::InBound_C*) &InBound;
}

Router::pScheduler_C::OutBound_C* Router::pScheduler_C::getOutBound() const {
    return (Router::pScheduler_C::OutBound_C*) &OutBound;
}

void Router::pScheduler_C::destroy() {
}

void Router::pScheduler_C::initRelations() {
    InBound._setPort(this);
}





Router::pScheduler_C::InBound_C::InBound_C() {
    itsISchedulerRouter3 = NULL;
    port = NULL;
}

Router::pScheduler_C::InBound_C::~InBound_C() {
    cleanUpRelations();
}

bool Router::pScheduler_C::InBound_C::send(IOxfEvent* event, const IOxfEventGenerationParams& params) {
    //#[ operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
    bool res = false;
    if (event != NULL) {
      event->setPort(getPort());
      	if (itsISchedulerRouter3 != NULL){
    	     if (event->isTypeOf(evTopology_Rip_id)){
         		res = itsISchedulerRouter3->send(event, params);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evInit_Rip_id)){
         		res = itsISchedulerRouter3->send(event, params);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evTimer_Rip_id)){
         		res = itsISchedulerRouter3->send(event, params);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

bool Router::pScheduler_C::InBound_C::send(IOxfEvent* event) {
    //#[ operation send(IOxfEvent*) 
    bool res = false;
    if (event != NULL) {
      event->setPort(getPort());
      	if (itsISchedulerRouter3 != NULL){
    	     if (event->isTypeOf(evTopology_Rip_id)){
         		res = itsISchedulerRouter3->send(event);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evInit_Rip_id)){
         		res = itsISchedulerRouter3->send(event);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evTimer_Rip_id)){
         		res = itsISchedulerRouter3->send(event);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

iSchedulerRouter3* Router::pScheduler_C::InBound_C::getItsISchedulerRouter3() const {
    return itsISchedulerRouter3;
}

void Router::pScheduler_C::InBound_C::setItsISchedulerRouter3(iSchedulerRouter3* p_iSchedulerRouter3) {
    itsISchedulerRouter3 = p_iSchedulerRouter3;
}

Router::pScheduler_C* Router::pScheduler_C::InBound_C::getPort() const {
    return port;
}

void Router::pScheduler_C::InBound_C::__setPort(Router::pScheduler_C* p_pScheduler_C) {
    port = p_pScheduler_C;
}

void Router::pScheduler_C::InBound_C::_setPort(Router::pScheduler_C* p_pScheduler_C) {
    __setPort(p_pScheduler_C);
}

void Router::pScheduler_C::InBound_C::setPort(Router::pScheduler_C* p_pScheduler_C) {
    _setPort(p_pScheduler_C);
}

void Router::pScheduler_C::InBound_C::_clearPort() {
    port = NULL;
}

void Router::pScheduler_C::InBound_C::cleanUpRelations() {
    if(itsISchedulerRouter3 != NULL)
        {
            itsISchedulerRouter3 = NULL;
        }
    if(port != NULL)
        {
            Router::pScheduler_C::InBound_C* p_InBound = port->getInBound();
            port = NULL;
        }
}






Router::pScheduler_C::OutBound_C::OutBound_C() {
    itsIRouterScheduler1 = NULL;
}

Router::pScheduler_C::OutBound_C::~OutBound_C() {
    cleanUpRelations();
}

bool Router::pScheduler_C::OutBound_C::send(IOxfEvent* event, const IOxfEventGenerationParams& params) {
    //#[ operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
    bool res = false;
    if (event != NULL) {
      	if (itsIRouterScheduler1 != NULL){
    	     if (event->isTypeOf(evRep_Init_Rip_id)){
         		res = itsIRouterScheduler1->send(event, params);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evTimer_Rip_id)){
         		res = itsIRouterScheduler1->send(event, params);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

bool Router::pScheduler_C::OutBound_C::send(IOxfEvent* event) {
    //#[ operation send(IOxfEvent*) 
    bool res = false;
    if (event != NULL) {
      	if (itsIRouterScheduler1 != NULL){
    	     if (event->isTypeOf(evRep_Init_Rip_id)){
         		res = itsIRouterScheduler1->send(event);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evTimer_Rip_id)){
         		res = itsIRouterScheduler1->send(event);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

OMReactive* Router::pScheduler_C::OutBound_C::getItsIRouterScheduler1() const {
    return itsIRouterScheduler1;
}

void Router::pScheduler_C::OutBound_C::setItsIRouterScheduler1(OMReactive* p_OMReactive) {
    itsIRouterScheduler1 = p_OMReactive;
}

void Router::pScheduler_C::OutBound_C::cleanUpRelations() {
    if(itsIRouterScheduler1 != NULL)
        {
            itsIRouterScheduler1 = NULL;
        }
}







Router::pRIP2_C::pRIP2_C() {
}

Router::pRIP2_C::~pRIP2_C() {
}

void Router::pRIP2_C::connectRouter(Router* part) {
    //#[ operation connectRouter(Router*) 
    InBound.setItsDefaultProvidedInterface(part);
    InBound.setPort(this); // for IS_PORT macro support
    
    //#]
}






Router::pRIP1_C::pRIP1_C() {
}

Router::pRIP1_C::~pRIP1_C() {
}

void Router::pRIP1_C::connectRouter(Router* part) {
    //#[ operation connectRouter(Router*) 
    InBound.setItsDefaultProvidedInterface(part);
    InBound.setPort(this); // for IS_PORT macro support
    
    //#]
}






Router::pRIP3_C::pRIP3_C() {
}

Router::pRIP3_C::~pRIP3_C() {
}

void Router::pRIP3_C::connectRouter(Router* part) {
    //#[ operation connectRouter(Router*) 
    InBound.setItsDefaultProvidedInterface(part);
    InBound.setPort(this); // for IS_PORT macro support
    
    //#]
}






Router::pRIP4_C::pRIP4_C() {
}

Router::pRIP4_C::~pRIP4_C() {
}

void Router::pRIP4_C::connectRouter(Router* part) {
    //#[ operation connectRouter(Router*) 
    InBound.setItsDefaultProvidedInterface(part);
    InBound.setPort(this); // for IS_PORT macro support
    
    //#]
}




#ifdef _OMINSTRUMENT


void OMAnimatedRouter::serializeAttributes(AOMSAttributes* aomsAttributes) const {
    aomsAttributes->addAttribute("numberOfInitializationMessagesReceived", x2String(myReal->numberOfInitializationMessagesReceived));
    aomsAttributes->addAttribute("neighbours", UNKNOWN2STRING(myReal->neighbours));
    aomsAttributes->addAttribute("nb_line", x2String(myReal->nb_line));
    aomsAttributes->addAttribute("rip_msg", UNKNOWN2STRING(myReal->rip_msg));
    aomsAttributes->addAttribute("numberOfReceivedRIPMessages", x2String(myReal->numberOfReceivedRIPMessages));
    aomsAttributes->addAttribute("numberOfNeighbours", x2String(myReal->numberOfNeighbours));
    aomsAttributes->addAttribute("i", x2String(myReal->i));
    aomsAttributes->addAttribute("routeT", UNKNOWN2STRING(myReal->routeT));
    aomsAttributes->addAttribute("NbNodes", x2String(myReal->NbNodes));
    aomsAttributes->addAttribute("j", x2String(myReal->j));
    aomsAttributes->addAttribute("routerID", x2String(myReal->routerID));
    aomsAttributes->addAttribute("ripMessagesReceived", UNKNOWN2STRING(myReal->ripMessagesReceived));
    aomsAttributes->addAttribute("n", x2String(myReal->n));
    aomsAttributes->addAttribute("received_rip", UNKNOWN2STRING(myReal->received_rip));
    aomsAttributes->addAttribute("n_line", x2String(myReal->n_line));
    aomsAttributes->addAttribute("k", x2String(myReal->k));
    aomsAttributes->addAttribute("senderRouter", x2String(myReal->senderRouter));
    aomsAttributes->addAttribute("next", x2String(myReal->next));
    aomsAttributes->addAttribute("cost", x2String(myReal->cost));
    aomsAttributes->addAttribute("m", x2String(myReal->m));
    aomsAttributes->addAttribute("dest", x2String(myReal->dest));
    aomsAttributes->addAttribute("receiverRouterID", x2String(myReal->receiverRouterID));
    aomsAttributes->addAttribute("toSendRIPMessages", UNKNOWN2STRING(myReal->toSendRIPMessages));
    aomsAttributes->addAttribute("l", x2String(myReal->l));
    OMAnimatediSchedulerRouter3::serializeAttributes(aomsAttributes);
}

void OMAnimatedRouter::serializeRelations(AOMSRelations* aomsRelations) const {
    OMAnimatediSchedulerRouter3::serializeRelations(aomsRelations);
}

void OMAnimatedRouter::rootState_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT");
    switch (myReal->rootState_subState) {
        case Router::mainState:
        {
            mainState_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedRouter::mainState_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState");
    switch (myReal->mainState_subState) {
        case Router::Initial:
        {
            Initial_serializeStates(aomsState);
            break;
        }
        case Router::topologyReceived:
        {
            topologyReceived_serializeStates(aomsState);
            break;
        }
        case Router::IDReceived:
        {
            IDReceived_serializeStates(aomsState);
            break;
        }
        case Router::AckSent:
        {
            AckSent_serializeStates(aomsState);
            break;
        }
        case Router::SendingAndReceivingRIPMessages_ReceivingNewTopology:
        {
            SendingAndReceivingRIPMessages_ReceivingNewTopology_serializeStates(aomsState);
            break;
        }
        case Router::RIPMessagesSent:
        {
            RIPMessagesSent_serializeStates(aomsState);
            break;
        }
        case Router::TableUpdate:
        {
            TableUpdate_serializeStates(aomsState);
            break;
        }
        case Router::RIPMessageReceived:
        {
            RIPMessageReceived_serializeStates(aomsState);
            break;
        }
        case Router::CreateInitialTable:
        {
            CreateInitialTable_serializeStates(aomsState);
            break;
        }
        case Router::CreateRIPmessage:
        {
            CreateRIPmessage_serializeStates(aomsState);
            break;
        }
        case Router::CreateNewTable:
        {
            CreateNewTable_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedRouter::topologyReceived_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.topologyReceived");
}

void OMAnimatedRouter::TableUpdate_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.TableUpdate");
    switch (myReal->TableUpdate_subState) {
        case Router::TableUpdate_Initial:
        {
            TableUpdate_Initial_serializeStates(aomsState);
            break;
        }
        case Router::Processing:
        {
            Processing_serializeStates(aomsState);
            break;
        }
        case Router::CheckingNextLine:
        {
            CheckingNextLine_serializeStates(aomsState);
            break;
        }
        case Router::CheckingRIPMessage:
        {
            CheckingRIPMessage_serializeStates(aomsState);
            break;
        }
        case Router::CheckingNextRIPMessage:
        {
            CheckingNextRIPMessage_serializeStates(aomsState);
            break;
        }
        case Router::state_53:
        {
            state_53_serializeStates(aomsState);
            break;
        }
        case Router::SavingSenderRouterID:
        {
            SavingSenderRouterID_serializeStates(aomsState);
            break;
        }
        case Router::CostUpdate:
        {
            CostUpdate_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedRouter::state_53_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.TableUpdate.ROOT.TableUpdate.state_53");
}

void OMAnimatedRouter::SavingSenderRouterID_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.TableUpdate.ROOT.TableUpdate.SavingSenderRouterID");
}

void OMAnimatedRouter::Processing_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.TableUpdate.ROOT.TableUpdate.Processing");
}

void OMAnimatedRouter::TableUpdate_Initial_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.TableUpdate.ROOT.TableUpdate.Initial");
}

void OMAnimatedRouter::CostUpdate_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate");
    switch (myReal->CostUpdate_subState) {
        case Router::CostUpdate_Initial:
        {
            CostUpdate_Initial_serializeStates(aomsState);
            break;
        }
        case Router::Modifying:
        {
            Modifying_serializeStates(aomsState);
            break;
        }
        case Router::ModifyingTheTable:
        {
            ModifyingTheTable_serializeStates(aomsState);
            break;
        }
        case Router::state_59:
        {
            state_59_serializeStates(aomsState);
            break;
        }
        case Router::ChangingTheNextHop:
        {
            ChangingTheNextHop_serializeStates(aomsState);
            break;
        }
        case Router::ModificationComplete:
        {
            ModificationComplete_serializeStates(aomsState);
            break;
        }
        case Router::Adding:
        {
            Adding_serializeStates(aomsState);
            break;
        }
        case Router::state_63:
        {
            state_63_serializeStates(aomsState);
            break;
        }
        case Router::AddingToRoutingTable:
        {
            AddingToRoutingTable_serializeStates(aomsState);
            break;
        }
        case Router::state_65:
        {
            state_65_serializeStates(aomsState);
            break;
        }
        case Router::InitializingCounter:
        {
            InitializingCounter_serializeStates(aomsState);
            break;
        }
        case Router::state_70:
        {
            state_70_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedRouter::state_70_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.state_70");
}

void OMAnimatedRouter::state_65_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.state_65");
}

void OMAnimatedRouter::state_63_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.state_63");
}

void OMAnimatedRouter::state_59_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.state_59");
}

void OMAnimatedRouter::ModifyingTheTable_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.ModifyingTheTable");
}

void OMAnimatedRouter::Modifying_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.Modifying");
}

void OMAnimatedRouter::ModificationComplete_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.ModificationComplete");
}

void OMAnimatedRouter::InitializingCounter_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.InitializingCounter");
}

void OMAnimatedRouter::CostUpdate_Initial_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.Initial");
}

void OMAnimatedRouter::ChangingTheNextHop_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.ChangingTheNextHop");
}

void OMAnimatedRouter::AddingToRoutingTable_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.AddingToRoutingTable");
}

void OMAnimatedRouter::Adding_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CostUpdate.ROOT.CostUpdate.Adding");
}

void OMAnimatedRouter::CheckingRIPMessage_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CheckingRIPMessage");
}

void OMAnimatedRouter::CheckingNextRIPMessage_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CheckingNextRIPMessage");
}

void OMAnimatedRouter::CheckingNextLine_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.TableUpdate.ROOT.TableUpdate.CheckingNextLine");
}

void OMAnimatedRouter::SendingAndReceivingRIPMessages_ReceivingNewTopology_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.SendingAndReceivingRIPMessages_ReceivingNewTopology");
}

void OMAnimatedRouter::RIPMessagesSent_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.RIPMessagesSent");
}

void OMAnimatedRouter::RIPMessageReceived_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.RIPMessageReceived");
}

void OMAnimatedRouter::Initial_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.Initial");
}

void OMAnimatedRouter::IDReceived_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.IDReceived");
}

void OMAnimatedRouter::CreateRIPmessage_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.CreateRIPmessage");
    switch (myReal->CreateRIPmessage_subState) {
        case Router::CreateRIPmessage_Initial:
        {
            CreateRIPmessage_Initial_serializeStates(aomsState);
            break;
        }
        case Router::CountersSet:
        {
            CountersSet_serializeStates(aomsState);
            break;
        }
        case Router::AddingItselfToRIPMessage:
        {
            AddingItselfToRIPMessage_serializeStates(aomsState);
            break;
        }
        case Router::AddingLinesToRIPMessage:
        {
            AddingLinesToRIPMessage_serializeStates(aomsState);
            break;
        }
        case Router::OthersAdded:
        {
            OthersAdded_serializeStates(aomsState);
            break;
        }
        case Router::LinesAdded:
        {
            LinesAdded_serializeStates(aomsState);
            break;
        }
        case Router::SendingRIPMessage:
        {
            SendingRIPMessage_serializeStates(aomsState);
            break;
        }
        case Router::state_45:
        {
            state_45_serializeStates(aomsState);
            break;
        }
        case Router::CustomizingEachMessage:
        {
            CustomizingEachMessage_serializeStates(aomsState);
            break;
        }
        case Router::ExcludingLinesOfAParticularReceiver:
        {
            ExcludingLinesOfAParticularReceiver_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedRouter::state_45_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.state_45");
}

void OMAnimatedRouter::SendingRIPMessage_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.SendingRIPMessage");
}

void OMAnimatedRouter::OthersAdded_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.OthersAdded");
}

void OMAnimatedRouter::LinesAdded_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.LinesAdded");
}

void OMAnimatedRouter::CreateRIPmessage_Initial_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.Initial");
}

void OMAnimatedRouter::ExcludingLinesOfAParticularReceiver_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.ExcludingLinesOfAParticularReceiver");
}

void OMAnimatedRouter::CustomizingEachMessage_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.CustomizingEachMessage");
}

void OMAnimatedRouter::CountersSet_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.CountersSet");
}

void OMAnimatedRouter::AddingLinesToRIPMessage_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.AddingLinesToRIPMessage");
}

void OMAnimatedRouter::AddingItselfToRIPMessage_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.CreateRIPmessage.ROOT.CreateRIPmessage.AddingItselfToRIPMessage");
}

void OMAnimatedRouter::CreateNewTable_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.CreateNewTable");
    switch (myReal->CreateNewTable_subState) {
        case Router::CreateNewTable_Initial:
        {
            CreateNewTable_Initial_serializeStates(aomsState);
            break;
        }
        case Router::CreateNewTable_Start:
        {
            CreateNewTable_Start_serializeStates(aomsState);
            break;
        }
        case Router::CreateNewTable_SettingInactiveLinks:
        {
            CreateNewTable_SettingInactiveLinks_serializeStates(aomsState);
            break;
        }
        case Router::CreateNewTable_SettingActiveLinks:
        {
            CreateNewTable_SettingActiveLinks_serializeStates(aomsState);
            break;
        }
        case Router::CreateNewTable_TableUpdated:
        {
            CreateNewTable_TableUpdated_serializeStates(aomsState);
            break;
        }
        case Router::CreateNewTable_state_31:
        {
            CreateNewTable_state_31_serializeStates(aomsState);
            break;
        }
        case Router::CreateNewTable_IncrementingTheCounter:
        {
            CreateNewTable_IncrementingTheCounter_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedRouter::CreateNewTable_TableUpdated_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.CreateNewTable.ROOT.CreateNewTable.TableUpdated");
}

void OMAnimatedRouter::CreateNewTable_state_31_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.CreateNewTable.ROOT.CreateNewTable.state_31");
}

void OMAnimatedRouter::CreateNewTable_Start_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.CreateNewTable.ROOT.CreateNewTable.Start");
}

void OMAnimatedRouter::CreateNewTable_SettingInactiveLinks_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.CreateNewTable.ROOT.CreateNewTable.SettingInactiveLinks");
}

void OMAnimatedRouter::CreateNewTable_SettingActiveLinks_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.CreateNewTable.ROOT.CreateNewTable.SettingActiveLinks");
}

void OMAnimatedRouter::CreateNewTable_Initial_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.CreateNewTable.ROOT.CreateNewTable.Initial");
}

void OMAnimatedRouter::CreateNewTable_IncrementingTheCounter_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.CreateNewTable.ROOT.CreateNewTable.IncrementingTheCounter");
}

void OMAnimatedRouter::CreateInitialTable_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.CreateInitialTable");
    switch (myReal->CreateInitialTable_subState) {
        case Router::CreateInitialTable_Initial:
        {
            CreateInitialTable_Initial_serializeStates(aomsState);
            break;
        }
        case Router::Start:
        {
            Start_serializeStates(aomsState);
            break;
        }
        case Router::SettingInactiveLinks:
        {
            SettingInactiveLinks_serializeStates(aomsState);
            break;
        }
        case Router::SettingActiveLinks:
        {
            SettingActiveLinks_serializeStates(aomsState);
            break;
        }
        case Router::TableUpdated:
        {
            TableUpdated_serializeStates(aomsState);
            break;
        }
        case Router::state_31:
        {
            state_31_serializeStates(aomsState);
            break;
        }
        case Router::IncrementingTheCounter:
        {
            IncrementingTheCounter_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedRouter::TableUpdated_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.CreateInitialTable.ROOT.CreateInitialTable.TableUpdated");
}

void OMAnimatedRouter::state_31_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.CreateInitialTable.ROOT.CreateInitialTable.state_31");
}

void OMAnimatedRouter::Start_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.CreateInitialTable.ROOT.CreateInitialTable.Start");
}

void OMAnimatedRouter::SettingInactiveLinks_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.CreateInitialTable.ROOT.CreateInitialTable.SettingInactiveLinks");
}

void OMAnimatedRouter::SettingActiveLinks_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.CreateInitialTable.ROOT.CreateInitialTable.SettingActiveLinks");
}

void OMAnimatedRouter::CreateInitialTable_Initial_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.CreateInitialTable.ROOT.CreateInitialTable.Initial");
}

void OMAnimatedRouter::IncrementingTheCounter_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.CreateInitialTable.ROOT.CreateInitialTable.IncrementingTheCounter");
}

void OMAnimatedRouter::AckSent_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.AckSent");
}

IMPLEMENT_REACTIVE_META_S(Router, false, iSchedulerRouter3, OMAnimatediSchedulerRouter3, OMAnimatedRouter)
OMINIT_SUPERCLASS(iSchedulerRouter3, OMAnimatediSchedulerRouter3)
OMREGISTER_REACTIVE_CLASS
#endif // _OMINSTRUMENT


/*********************************************************************
	File Path	: mainComponent/DefaultConfig/Router.cpp
*********************************************************************/

